displayFile("<div class=\"file\">\n  <h2 id=\"src/middleware/filterMongooseExists.js\"> src/middleware/filterMongooseExists.js</h2>\n  <div id=\"stats\">\n    <div class=\"linecoverage\">\n      <span class=\"linecov medium\">\n        [83.33%]\n      </span>\n      <span>15/18<span>\n      <span class=\"misses\">\n        3\n      </span>\n    </div>\n    <div class=\"branchcoverage\">\n      <span class=\"branchcov medium\">\n        [94.12%]\n      </span>\n      <span>16/17</span>\n      <span class=\"misses\">\n        1\n      </span>\n    </div>\n  </div>\n  <table id=\"source\">\n    <thead>\n      <tr>\n        <th>Line</th>\n        <th>Hits</th>\n        <th>Source</th>\n      </tr>\n    </thead>\n    <tbody>\n      \n      \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">1</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">'use strict';</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">2</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">3</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">var debug = require('debug')('formio:middleware:filterMongooseExists');</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">4</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">5</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">/**</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">6</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> * Middleware to filter the Mongoose query for the existance of a field, using the provided settings,</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">7</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">8</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> * @param router</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">9</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> * @param settings</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">10</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> *   settings.field {string} The field in which to search for.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">11</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> *   settings.isNull {boolean} Whether or not the field contains a non-null value.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">12</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> *</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">13</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> * @returns {Function}</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">14</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"> */</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">15</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">module.exports = function(router) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">16</td>\n              <td class=\"hits\">1</td>\n              <td class=\"source\">  return function(settings) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">17</td>\n              <td class=\"hits\">12</td>\n              <td class=\"source\">    return function(req, res, next) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">18</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Only filter on non empty objects.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">19</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      debug(settings);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">20</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!settings || typeof settings !== 'object' || settings === {}) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">21</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">22</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">23</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Verify the field settings.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">24</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!settings.hasOwnProperty('field') || !settings.field) {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">25</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">26</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">27</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Verify the existance settings.</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">28</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      if (!settings.hasOwnProperty('isNull') || typeof settings.isNull !== 'boolean') {</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss\">\n              <td class=\"line\">29</td>\n              <td class=\"hits\">0</td>\n              <td class=\"source\">        return next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">30</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      }</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">31</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">32</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Set the exist modifier.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">33</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      var exists = settings.isNull</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">34</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        ? {$eq: null}</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"miss-branch\">\n              <td class=\"line\">35</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">        : <i class=\"cond-miss\">{$ne: null}</i>;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">36</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">37</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">      // Build the dynamic mongoose query.</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">38</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      var query = {};</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">39</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      query[settings.field] = exists;</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">40</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">41</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      debug(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">42</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      req.modelQuery = req.modelQuery || this.model;</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">43</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      req.modelQuery = req.modelQuery.find(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">44</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">45</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      req.countQuery = req.countQuery || this.model;</td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">46</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      req.countQuery = req.countQuery.find(query);</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">47</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n        \n        \n            <tr class=\"hit\">\n              <td class=\"line\">48</td>\n              <td class=\"hits\">506</td>\n              <td class=\"source\">      next();</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">49</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">    };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">50</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">  };</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">51</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\">};</td>\n            </tr>\n        \n      \n        \n        \n            <tr>\n              <td class=\"line\">52</td>\n              <td class=\"hits\"></td>\n              <td class=\"source\"></td>\n            </tr>\n        \n      \n    </tbody>\n  </table>\n</div>");